﻿namespace IDisposableExceptionDemo
{
    using System;
    using System.Runtime.InteropServices;

    /// <summary>Test class.</summary>
    public class DisposableObject : IDisposable
    {
        /// <summary>IDisposable implementation that checks for an exception.</summary>
        void IDisposable.Dispose()
        {
            // Check for an exception
            if (Marshal.GetExceptionCode() != 0) {
                Console.WriteLine("Dispose() > Exception detected!");
                return;
            }

            Console.WriteLine("Dispose() > Completed successfully!");
        }

        /// <summary>Throwing demo exception.</summary>
        public void ExceptionTest()
        {
            Console.WriteLine("IDisposableObject.ExceptionTest() > throwing exception ...");
            throw new NotImplementedException();
        }
    }
}
